#include "lcd.h"
#include <pic18.h>


// LCD ----------------------------------------------
// Init LCD
void InitLCD(void) {
	
	// LCDCON -> 1/4 COM3-COM1, LCD Driver Enable, Enable Sleep Mode 
	LCDCON 	= 0x83;
	
	// LCDPS -> Prescaler 1/1, Active mode, Write to LCD data
	LCDPS 	= 0x30;
	// LCD Segment select function
	LCDSE0 	= 0xFF;
	LCDSE1 	= 0x03;
	LCDSE2 	= 0xFF;
	LCDSE3 	= 0xFF;
	LCDSE4 	= 0xFF;
	LCDSE5 	= 0xFF;

}

// turn on All segment
void LCD_light_all(void) {

	LCDDATA0  = 0xFF; LCDDATA1  = 0xFF; LCDDATA2  = 0xFF; LCDDATA3  = 0xFF;
	LCDDATA4  = 0xFF; LCDDATA5  = 0xFF; LCDDATA6  = 0xFF; LCDDATA7  = 0xFF;
	LCDDATA8  = 0xFF; LCDDATA9  = 0xFF; LCDDATA10 = 0xFF; LCDDATA11 = 0xFF;
	LCDDATA12 = 0xFF; LCDDATA13 = 0xFF; LCDDATA14 = 0xFF; LCDDATA15	= 0xFF;
	LCDDATA16 = 0xFF; LCDDATA17 = 0xFF; LCDDATA18 = 0xFF; LCDDATA19	= 0xFF;
	LCDDATA20 = 0xFF; LCDDATA21 = 0xFF;	LCDDATA22 = 0xFF; LCDDATA23	= 0xFF;
}

// turn off All segment
void LCD_clear_all(void) {

	LCDDATA0  = 0x0; LCDDATA1  = 0x0; LCDDATA2  = 0x0; LCDDATA3  = 0x0;
	LCDDATA4  = 0x0; LCDDATA5  = 0x0; LCDDATA6  = 0x0; LCDDATA7  = 0x0;
	LCDDATA8  = 0x0; LCDDATA9  = 0x0; LCDDATA10 = 0x0; LCDDATA11 = 0x0;
	LCDDATA12 = 0x0; LCDDATA13 = 0x0; LCDDATA14 = 0x0; LCDDATA15 = 0x0;
	LCDDATA16 = 0x0; LCDDATA17 = 0x0; LCDDATA18 = 0x0; LCDDATA19 = 0x0;
	LCDDATA20 = 0x0; LCDDATA21 = 0x0; LCDDATA22 = 0x0; LCDDATA23 = 0x0;
}


void FormatChar_7(unsigned char ch)
{

  switch(ch)
  {
    case '0': A7; B7; C7; D7; F7; E7; 	break;
    case '1': B7; C7; 	break;
    case '2': A7; B7; M7; D7; G7; E7; 	break;
    case '3': A7; B7; C7; M7; D7; G7;	break;
    case '4': B7; C7; M7; G7; F7;	break;
    case '5': A7; M7; C7; D7; G7; F7; break;
    case '6': A7; M7; C7; D7; G7; F7; E7; break;
    case '7': A7; B7; C7; break;
    case '8': A7; B7; C7; M7; D7; G7; F7; E7; break;
    case '9': A7; B7; C7; M7; D7; G7; F7; break;
    case 'A': A7; B7; C7; M7; E7; F7; G7; break;
    case 'B': A7; K7; M7; C7; D7; F7; G7; E7; break;
    case 'C': A7; D7; F7; E7; break;
    case 'D': D7; N7; F7; E7; H7; break;
    case 'E': A7; D7; F7; G7; E7; break;
    case 'F': A7; F7; G7; E7; break;
    case 'G': A7; M7; C7; D7; F7; E7; break;
    case 'H': B7; M7; C7; F7; G7; E7; break;
    case 'I': A7; J7; D7; P7; break;
    case 'J': B7; C7; D7; E7; break;
    case 'K': K7; N7; F7; G7; E7; break;
    case 'L': D7; F7; E7; break;
    case 'M': K7; B7; C7; F7; E7; H7; break;
    case 'N': N7; B7; C7; F7; E7; H7; break;
    case 'O': A7; B7; C7; D7; F7; E7; break;
    case 'P': A7; B7; M7; F7; G7; E7; break;
    case 'Q': A7; B7; C7; D7; N7; F7; E7; break;
    case 'R': A7; B7; M7; N7; F7; G7; E7; break;
    case 'S': A7; M7; C7; D7; F7 G7; break;
    case 'T': A7; J7; P7; break;
    case 'U': B7; C7; D7; F7; E7; break;
    case 'V': B7; C7; N7; H7; break;
    case 'W': B7; C7; D7; Q7; F7; E7; break;
    case 'X': K7; N7; H7; Q7; break;
    case 'Y': B7; M7; C7; D7; F7; G7; break;
    case 'Z': A7; K7; D7; Q7; break;
	case '-': G7; M7; break;
  }
}

void FormatChar_6(unsigned char ch)
{

	  switch(ch)
	  {
	    case '0': A6; B6; C6; D6; F6; E6; 	break;
	    case '1': B6; C6; 	break;
	    case '2': A6; B6; M6; D6; G6; E6; 	break;
	    case '3': A6; B6; C6; M6; D6; G6;	break;
	    case '4': B6; C6; M6; G6; F6;	break;
	    case '5': A6; M6; C6; D6; G6; F6; break;
	    case '6': A6; M6; C6; D6; G6; F6; E6; break;
	    case '7': A6; B6; C6; break;
	    case '8': A6; B6; C6; M6; D6; G6; F6; E6; break;
	    case '9': A6; B6; C6; M6; D6; G6; F6; break;
	    case 'A': A6; B6; C6; M6; E6; F6; G6; break;
	    case 'B': A6; K6; M6; C6; D6; F6; G6; E6; break;
	    case 'C': A6; D6; F6; E6; break;
	    case 'D': D6; N6; F6; E6; H6; break;
	    case 'E': A6; D6; F6; G6; E6; break;
	    case 'F': A6; F6; G6; E6; break;
	    case 'G': A6; M6; C6; D6; F6; E6; break;
	    case 'H': B6; M6; C6; F6; G6; E6; break;
	    case 'I': A6; J6; D6; P6; break;
	    case 'J': B6; C6; D6; E6; break;
	    case 'K': K6; N6; F6; G6; E6; break;
	    case 'L': D6; F6; E6; break;
	    case 'M': K6; B6; C6; F6; E6; H6; break;
	    case 'N': N6; B6; C6; F6; E6; H6; break;
	    case 'O': A6; B6; C6; D6; F6; E6; break;
	    case 'P': A6; B6; M6; F6; G6; E6; break;
	    case 'Q': A6; B6; C6; D6; N6; F6; E6; break;
	    case 'R': A6; B6; M6; N6; F6; G6; E6; break;
	    case 'S': A6; M6; C6; D6; F6 G6; break;
	    case 'T': A6; J6; P6; break;
	    case 'U': B6; C6; D6; F6; E6; break;
	    case 'V': B6; C6; N6; H6; break;
	    case 'W': B6; C6; D6; Q6; F6; E6; break;
	    case 'X': K6; N6; H6; Q6; break;
	    case 'Y': B6; M6; C6; D6; F6; G6; break;
	    case 'Z': A6; K6; D6; Q6; break;
		case '-': G6; M6; break;
	  }
}

void FormatChar_5(unsigned char ch)
{

	  switch(ch)
	  {
	    case '0': A5; B5; C5; D5; F5; E5; 	break;
	    case '1': B5; C5; 	break;
	    case '2': A5; B5; M5; D5; G5; E5; 	break;
	    case '3': A5; B5; C5; M5; D5; G5;	break;
	    case '4': B5; C5; M5; G5; F5;	break;
	    case '5': A5; M5; C5; D5; G5; F5; break;
	    case '6': A5; M5; C5; D5; G5; F5; E5; break;
	    case '7': A5; B5; C5; break;
	    case '8': A5; B5; C5; M5; D5; G5; F5; E5; break;
	    case '9': A5; B5; C5; M5; D5; G5; F5; break;
	    case 'A': A5; B5; C5; M5; E5; F5; G5; break;
	    case 'B': A5; K5; M5; C5; D5; F5; G5; E5; break;
	    case 'C': A5; D5; F5; E5; break;
	    case 'D': D5; N5; F5; E5; H5; break;
	    case 'E': A5; D5; F5; G5; E5; break;
	    case 'F': A5; F5; G5; E5; break;
	    case 'G': A5; M5; C5; D5; F5; E5; break;
	    case 'H': B5; M5; C5; F5; G5; E5; break;
	    case 'I': A5; J5; D5; P5; break;
	    case 'J': B5; C5; D5; E5; break;
	    case 'K': K5; N5; F5; G5; E5; break;
	    case 'L': D5; F5; E5; break;
	    case 'M': K5; B5; C5; F5; E5; H5; break;
	    case 'N': N5; B5; C5; F5; E5; H5; break;
	    case 'O': A5; B5; C5; D5; F5; E5; break;
	    case 'P': A5; B5; M5; F5; G5; E5; break;
	    case 'Q': A5; B5; C5; D5; N5; F5; E5; break;
	    case 'R': A5; B5; M5; N5; F5; G5; E5; break;
	    case 'S': A5; M5; C5; D5; F5 G5; break;
	    case 'T': A5; J5; P5; break;
	    case 'U': B5; C5; D5; F5; E5; break;
	    case 'V': B5; C5; N5; H5; break;
	    case 'W': B5; C5; D5; Q5; F5; E5; break;
	    case 'X': K5; N5; H5; Q5; break;
	    case 'Y': B5; M5; C5; D5; F5; G5; break;
	    case 'Z': A5; K5; D5; Q5; break;
		case '-': G5; M5; break;
	  }
}

void FormatChar_4(unsigned char ch)
{

	  switch(ch)
	  {
	    case '0': A4; B4; C4; D4; F4; E4; 	break;
	    case '1': B4; C4; 	break;
	    case '2': A4; B4; M4; D4; G4; E4; 	break;
	    case '3': A4; B4; C4; M4; D4; G4;	break;
	    case '4': B4; C4; M4; G4; F4;	break;
	    case '5': A4; M4; C4; D4; G4; F4; break;
	    case '6': A4; M4; C4; D4; G4; F4; E4; break;
	    case '7': A4; B4; C4; break;
	    case '8': A4; B4; C4; M4; D4; G4; F4; E4; break;
	    case '9': A4; B4; C4; M4; D4; G4; F4; break;
	    case 'A': A4; B4; C4; M4; E4; F4; G4; break;
	    case 'B': A4; K4; M4; C4; D4; F4; G4; E4; break;
	    case 'C': A4; D4; F4; E4; break;
	    case 'D': D4; N4; F4; E4; H4; break;
	    case 'E': A4; D4; F4; G4; E4; break;
	    case 'F': A4; F4; G4; E4; break;
	    case 'G': A4; M4; C4; D4; F4; E4; break;
	    case 'H': B4; M4; C4; F4; G4; E4; break;
	    case 'I': A4; J4; D4; P4; break;
	    case 'J': B4; C4; D4; E4; break;
	    case 'K': K4; N4; F4; G4; E4; break;
	    case 'L': D4; F4; E4; break;
	    case 'M': K4; B4; C4; F4; E4; H4; break;
	    case 'N': N4; B4; C4; F4; E4; H4; break;
	    case 'O': A4; B4; C4; D4; F4; E4; break;
	    case 'P': A4; B4; M4; F4; G4; E4; break;
	    case 'Q': A4; B4; C4; D4; N4; F4; E4; break;
	    case 'R': A4; B4; M4; N4; F4; G4; E4; break;
	    case 'S': A4; M4; C4; D4; F4 G4; break;
	    case 'T': A4; J4; P4; break;
	    case 'U': B4; C4; D4; F4; E4; break;
	    case 'V': B4; C4; N4; H4; break;
	    case 'W': B4; C4; D4; Q4; F4; E4; break;
	    case 'X': K4; N4; H4; Q4; break;
	    case 'Y': B4; M4; C4; D4; F4; G4; break;
	    case 'Z': A4; K4; D4; Q4; break;
		case '-': G4; M4; break;
	  }
}

void FormatChar_3(unsigned char ch)
{

	  switch(ch)
	  {
	    case '0': A3; B3; C3; D3; F3; E3; 	break;
	    case '1': B3; C3; 	break;
	    case '2': A3; B3; M3; D3; G3; E3; 	break;
	    case '3': A3; B3; C3; M3; D3; G3;	break;
	    case '4': B3; C3; M3; G3; F3;	break;
	    case '5': A3; M3; C3; D3; G3; F3; break;
	    case '6': A3; M3; C3; D3; G3; F3; E3; break;
	    case '7': A3; B3; C3; break;
	    case '8': A3; B3; C3; M3; D3; G3; F3; E3; break;
	    case '9': A3; B3; C3; M3; D3; G3; F3; break;
	    case 'A': A3; B3; C3; M3; E3; F3; G3; break;
	    case 'B': A3; K3; M3; C3; D3; F3; G3; E3; break;
	    case 'C': A3; D3; F3; E3; break;
	    case 'D': D3; N3; F3; E3; H3; break;
	    case 'E': A3; D3; F3; G3; E3; break;
	    case 'F': A3; F3; G3; E3; break;
	    case 'G': A3; M3; C3; D3; F3; E3; break;
	    case 'H': B3; M3; C3; F3; G3; E3; break;
	    case 'I': A3; J3; D3; P3; break;
	    case 'J': B3; C3; D3; E3; break;
	    case 'K': K3; N3; F3; G3; E3; break;
	    case 'L': D3; F3; E3; break;
	    case 'M': K3; B3; C3; F3; E3; H3; break;
	    case 'N': N3; B3; C3; F3; E3; H3; break;
	    case 'O': A3; B3; C3; D3; F3; E3; break;
	    case 'P': A3; B3; M3; F3; G3; E3; break;
	    case 'Q': A3; B3; C3; D3; N3; F3; E3; break;
	    case 'R': A3; B3; M3; N3; F3; G3; E3; break;
	    case 'S': A3; M3; C3; D3; F3 G3; break;
	    case 'T': A3; J3; P3; break;
	    case 'U': B3; C3; D3; F3; E3; break;
	    case 'V': B3; C3; N3; H3; break;
	    case 'W': B3; C3; D3; Q3; F3; E3; break;
	    case 'X': K3; N3; H3; Q3; break;
	    case 'Y': B3; M3; C3; D3; F3; G3; break;
	    case 'Z': A3; K3; D3; Q3; break;
		case '-': G3; M3; break;
	  }
}
void FormatChar_2(unsigned char ch)
{

	  switch(ch)
	  {
	    case '0': A2; B2; C2; D2; F2; E2; 	break;
	    case '1': B2; C2; 	break;
	    case '2': A2; B2; M2; D2; G2; E2; 	break;
	    case '3': A2; B2; C2; M2; D2; G2;	break;
	    case '4': B2; C2; M2; G2; F2;	break;
	    case '5': A2; M2; C2; D2; G2; F2; break;
	    case '6': A2; M2; C2; D2; G2; F2; E2; break;
	    case '7': A2; B2; C2; break;
	    case '8': A2; B2; C2; M2; D2; G2; F2; E2; break;
	    case '9': A2; B2; C2; M2; D2; G2; F2; break;
	    case 'A': A2; B2; C2; M2; E2; F2; G2; break;
	    case 'B': A2; K2; M2; C2; D2; F2; G2; E2; break;
	    case 'C': A2; D2; F2; E2; break;
	    case 'D': D2; N2; F2; E2; H2; break;
	    case 'E': A2; D2; F2; G2; E2; break;
	    case 'F': A2; F2; G2; E2; break;
	    case 'G': A2; M2; C2; D2; F2; E2; break;
	    case 'H': B2; M2; C2; F2; G2; E2; break;
	    case 'I': A2; J2; D2; P2; break;
	    case 'J': B2; C2; D2; E2; break;
	    case 'K': K2; N2; F2; G2; E2; break;
	    case 'L': D2; F2; E2; break;
	    case 'M': K2; B2; C2; F2; E2; H2; break;
	    case 'N': N2; B2; C2; F2; E2; H2; break;
	    case 'O': A2; B2; C2; D2; F2; E2; break;
	    case 'P': A2; B2; M2; F2; G2; E2; break;
	    case 'Q': A2; B2; C2; D2; N2; F2; E2; break;
	    case 'R': A2; B2; M2; N2; F2; G2; E2; break;
	    case 'S': A2; M2; C2; D2; F2 G2; break;
	    case 'T': A2; J2; P2; break;
	    case 'U': B2; C2; D2; F2; E2; break;
	    case 'V': B2; C2; N2; H2; break;
	    case 'W': B2; C2; D2; Q2; F2; E2; break;
	    case 'X': K2; N2; H2; Q2; break;
	    case 'Y': B2; M2; C2; D2; F2; G2; break;
	    case 'Z': A2; K2; D2; Q2; break;
		case '-': G2; M2; break;
	  }
}

void FormatChar_1(unsigned char ch)
{

	  switch(ch)
	  {
	    case '0': A1; B1; C1; D1; F1; E1; 	break;
	    case '1': B1; C1; 	break;
	    case '2': A1; B1; M1; D1; G1; E1; 	break;
	    case '3': A1; B1; C1; M1; D1; G1;	break;
	    case '4': B1; C1; M1; G1; F1;	break;
	    case '5': A1; M1; C1; D1; G1; F1; break;
	    case '6': A1; M1; C1; D1; G1; F1; E1; break;
	    case '7': A1; B1; C1; break;
	    case '8': A1; B1; C1; M1; D1; G1; F1; E1; break;
	    case '9': A1; B1; C1; M1; D1; G1; F1; break;
	    case 'A': A1; B1; C1; M1; E1; F1; G1; break;
	    case 'B': A1; K1; M1; C1; D1; F1; G1; E1; break;
	    case 'C': A1; D1; F1; E1; break;
	    case 'D': D1; N1; F1; E1; H1; break;
	    case 'E': A1; D1; F1; G1; E1; break;
	    case 'F': A1; F1; G1; E1; break;
	    case 'G': A1; M1; C1; D1; F1; E1; break;
	    case 'H': B1; M1; C1; F1; G1; E1; break;
	    case 'I': A1; J1; D1; P1; break;
	    case 'J': B1; C1; D1; E1; break;
	    case 'K': K1; N1; F1; G1; E1; break;
	    case 'L': D1; F1; E1; break;
	    case 'M': K1; B1; C1; F1; E1; H1; break;
	    case 'N': N1; B1; C1; F1; E1; H1; break;
	    case 'O': A1; B1; C1; D1; F1; E1; break;
	    case 'P': A1; B1; M1; F1; G1; E1; break;
	    case 'Q': A1; B1; C1; D1; N1; F1; E1; break;
	    case 'R': A1; B1; M1; N1; F1; G1; E1; break;
	    case 'S': A1; M1; C1; D1; F1 G1; break;
	    case 'T': A1; J1; P1; break;
	    case 'U': B1; C1; D1; F1; E1; break;
	    case 'V': B1; C1; N1; H1; break;
	    case 'W': B1; C1; D1; Q1; F1; E1; break;
	    case 'X': K1; N1; H1; Q1; break;
	    case 'Y': B1; M1; C1; D1; F1; G1; break;
	    case 'Z': A1; K1; D1; Q1; break;
		case '-': G1; M1; break;
	  }
}

void FormatClk_1(unsigned char n) {
	 
	switch(n)
	{
		case 0: a1; b1; c1; d1; e1; f1;	break;
		case 1: b1; c1; break;
		case 2: a1; b1; g1; e1; d1;	break;
		case 3: a1; b1; c1; d1; g1;	break;
		case 4: b1; c1; f1; g1; break;
		case 5: a1; c1; d1; f1; g1;	break;
		case 6: a1; c1; d1; f1; g1; e1;	break;
		case 7: a1; b1; c1; break;
		case 8: a1; b1; c1; d1; e1; f1; g1;	break;
		case 9: a1; b1; c1; d1; f1; g1;	break;
	}
}

void FormatClk_2(unsigned char n) {
	 
	switch(n)
	{
		case 0: a2; b2; c2; d2; e2; f2;	break;
		case 1: b2; c2; break;
		case 2: a2; b2; g2; e2; d2;	break;
		case 3: a2; b2; c2; d2; g2;	break;
		case 4: b2; c2; f2; g2; break;
		case 5: a2; c2; d2; f2; g2;	break;
		case 6: a2; c2; d2; f2; g2; e2;	break;
		case 7: a2; b2; c2; break;
		case 8: a2; b2; c2; d2; e2; f2; g2;	break;
		case 9: a2; b2; c2; d2; f2; g2;	break;
	}
}

void FormatClk_3(unsigned char n) {
	 
	switch(n)
	{
		case 0: a3; b3; c3; d3; e3; f3;	break;
		case 1: b3; c3; break;
		case 2: a3; b3; g3; e3; d3;	break;
		case 3: a3; b3; c3; d3; g3;	break;
		case 4: b3; c3; f3; g3; break;
		case 5: a3; c3; d3; f3; g3;	break;
		case 6: a3; c3; d3; f3; g3; e3;	break;
		case 7: a3; b3; c3; break;
		case 8: a3; b3; c3; d3; e3; f3; g3;	break;
		case 9: a3; b3; c3; d3; f3; g3;	break;
	}
}

void FormatClk_4(unsigned char n) {
	 
	switch(n)
	{
		case 0: a4; b4; c4; d4; e4; f4; break;
		case 1: b4; c4; break;
		case 2: a4; b4; g4; e4; d4;	break;
		case 3: a4; b4; c4; d4; g4;	break;
		case 4: b4; c4; f4; g4; break;
		case 5: a4; c4; d4; f4; g4;	break;
		case 6: a4; c4; d4; f4; g4; e4;	break;
		case 7: a4; b4; c4; break;
		case 8: a4; b4; c4; d4; e4; f4; g4;	break;
		case 9: a4; b4; c4; d4; f4; g4;	break;
	}
}


void LCDWriteClck(unsigned int number)
{
    int edi, des, sto, hil;
    
    edi = (number%10);
    des = (number%100 - edi)/10;
    sto = (number%1000 - des)/100;
    hil = (number%10000 - sto)/1000;
    
    FormatClk_1(edi); 
    FormatClk_2(des);
    FormatClk_3(sto);
    FormatClk_4(hil);
}

// Print current clock
void LCDPrintClck(char hour, char min)
{
	all_clk_off;	

    FormatClk_1((unsigned char)(min%10)); 
    FormatClk_2((unsigned char)(min/10));
    FormatClk_3((unsigned char)(hour%10));
    FormatClk_4((unsigned char)(hour/10));
}

void LCDWriteTxt(unsigned char* txt)
{
/*
	FormatChar_1(*txt++); 
	FormatChar_2(*txt++); 
	FormatChar_3(*txt++);
	FormatChar_4(*txt++);
	FormatChar_5(*txt++);
	FormatChar_6(*txt++);
	FormatChar_7(*txt++);
*/
}
