
/**** LCD PARTS ****/
// 7 CHAR
#define A7		LCDDATA20 |= 0x20;   
#define B7		LCDDATA14 |= 0x20;   
#define C7		LCDDATA8  |= 0x20;   
#define D7		LCDDATA2  |= 0x20;   	 
#define E7  	LCDDATA8  |= 0x80;   
#define F7  	LCDDATA14 |= 0x80;   
#define G7   	LCDDATA14 |= 0x40;   
#define M7   	LCDDATA8  |= 0x10;   
#define H7   	LCDDATA20 |= 0x40;   
#define J7   	LCDDATA20 |= 0x10;      
#define K7   	LCDDATA14 |= 0x10;   
#define N7   	LCDDATA2  |= 0x10;   
#define P7   	LCDDATA2  |= 0x40;   
#define Q7   	LCDDATA8  |= 0x40;   

#define all_7_off LCDDATA8 &= ~0xF0; LCDDATA2 &= ~0xF0; LCDDATA14 &= ~0xF0; LCDDATA20 &= ~0xF0;


// 6 CHAR
#define A6		LCDDATA21 |= 0x02;   
#define B6		LCDDATA15 |= 0x02;   
#define C6		LCDDATA9  |= 0x02;   
#define D6		LCDDATA3  |= 0x02;   	 
#define E6  	LCDDATA9  |= 0x08;   
#define F6  	LCDDATA15 |= 0x08;   
#define G6   	LCDDATA15 |= 0x04;   
#define M6   	LCDDATA9  |= 0x01;   
#define H6   	LCDDATA21 |= 0x04;   
#define J6   	LCDDATA21 |= 0x01;      
#define K6   	LCDDATA15 |= 0x01;   
#define N6   	LCDDATA3  |= 0x01;   
#define P6   	LCDDATA3  |= 0x04;   
#define Q6   	LCDDATA9  |= 0x04;   

#define all_6_off LCDDATA3 &= ~0x0F; LCDDATA9 &= ~0x0F; LCDDATA15 &= ~0x0F; LCDDATA21 &= ~0x0F;

// 5 CHAR
#define A5		LCDDATA21 |= 0x20;   
#define B5		LCDDATA15 |= 0x20;   
#define C5		LCDDATA9  |= 0x20;   
#define D5		LCDDATA3  |= 0x20;   	 
#define E5  	LCDDATA9  |= 0x80;   
#define F5  	LCDDATA15 |= 0x80;   
#define G5   	LCDDATA15 |= 0x40;   
#define M5   	LCDDATA9  |= 0x10;   
#define H5   	LCDDATA21 |= 0x40;   
#define J5   	LCDDATA21 |= 0x10;      
#define K5   	LCDDATA15 |= 0x10;   
#define N5   	LCDDATA3  |= 0x10;   
#define P5   	LCDDATA3  |= 0x40;   
#define Q5   	LCDDATA9  |= 0x40;  

#define all_5_off LCDDATA9 &= ~0xF0; LCDDATA3 &= ~0xF0; LCDDATA15 &= ~0xF0; LCDDATA21 &= ~0xF0; 


// 4 CHAR
#define A4		LCDDATA22 |= 0x02;   
#define B4		LCDDATA16 |= 0x02;   
#define C4		LCDDATA10 |= 0x02;   
#define D4		LCDDATA4  |= 0x02;   	 
#define E4  	LCDDATA10 |= 0x08;   
#define F4  	LCDDATA16 |= 0x08;   
#define G4   	LCDDATA16 |= 0x04;   
#define M4   	LCDDATA10 |= 0x01;   
#define H4   	LCDDATA22 |= 0x04;   
#define J4   	LCDDATA22 |= 0x01;      
#define K4   	LCDDATA16 |= 0x01;   
#define N4   	LCDDATA4  |= 0x01;   
#define P4   	LCDDATA4  |= 0x04;   
#define Q4   	LCDDATA10 |= 0x04;   

#define all_4_off LCDDATA10 &= ~0x0F; LCDDATA4 &= ~0x0F; LCDDATA16 &= ~0x0F; LCDDATA22 &= ~0x0F;
// 3 CHAR
#define A3		LCDDATA22 |= 0x20;   
#define B3		LCDDATA16 |= 0x20;   
#define C3		LCDDATA10 |= 0x20;   
#define D3		LCDDATA4  |= 0x20;   	 
#define E3  	LCDDATA10 |= 0x80;   
#define F3  	LCDDATA16 |= 0x80;   
#define G3   	LCDDATA16 |= 0x40;   
#define M3   	LCDDATA10 |= 0x10;   
#define H3   	LCDDATA22 |= 0x40;   
#define J3   	LCDDATA22 |= 0x10;      
#define K3   	LCDDATA16 |= 0x10;   
#define N3   	LCDDATA4  |= 0x10;   
#define P3   	LCDDATA4  |= 0x40;   
#define Q3   	LCDDATA10 |= 0x40;   

#define all_3_off LCDDATA10 &= ~0xF0; LCDDATA4 &= ~0xF0; LCDDATA16 &= ~0xF0; LCDDATA22 &= ~0xF0;

// 2 CHAR
#define A2		LCDDATA23 |= 0x02;   
#define B2		LCDDATA17 |= 0x02;   
#define C2		LCDDATA11 |= 0x02;   
#define D2		LCDDATA5  |= 0x02;   	 
#define E2  	LCDDATA11 |= 0x08;   
#define F2  	LCDDATA17 |= 0x08;   
#define G2   	LCDDATA17 |= 0x04;   
#define M2   	LCDDATA11 |= 0x01;   
#define H2   	LCDDATA23 |= 0x04;   
#define J2   	LCDDATA23 |= 0x01;      
#define K2   	LCDDATA17 |= 0x01;   
#define N2   	LCDDATA5  |= 0x01;   
#define P2   	LCDDATA5  |= 0x04;   
#define Q2   	LCDDATA11 |= 0x04;   

#define all_2_off LCDDATA11 &= ~0x0F; LCDDATA5 &= ~0x0F; LCDDATA17 &= ~0x0F; LCDDATA23 &= ~0x0F;


// 1 CHAR
#define A1		LCDDATA23 |= 0x20;   
#define B1		LCDDATA17 |= 0x20;   
#define C1		LCDDATA11 |= 0x20;   
#define D1		LCDDATA5  |= 0x20;   	 
#define E1  	LCDDATA11 |= 0x80;   
#define F1  	LCDDATA17 |= 0x80;   
#define G1   	LCDDATA17 |= 0x40;   
#define M1   	LCDDATA11 |= 0x10;   
#define H1   	LCDDATA23 |= 0x40;   
#define J1   	LCDDATA23 |= 0x10;      
#define K1   	LCDDATA17 |= 0x10;   
#define N1   	LCDDATA5  |= 0x10;   
#define P1   	LCDDATA5  |= 0x40;   
#define Q1   	LCDDATA11 |= 0x40;   

#define all_1_off LCDDATA11 &= ~0xF0; LCDDATA5 &= ~0xF0; LCDDATA17 &= ~0xF0; LCDDATA23 &= ~0xF0;

#define DOT1	LCDDATA2  |= 0x80;  
#define DOT2	LCDDATA3  |= 0x08; 
#define DOT3	LCDDATA3  |= 0x80;
#define DOT4	LCDDATA4  |= 0x08; 
#define DOT5	LCDDATA4  |= 0x80; 
#define DOT6	LCDDATA5  |= 0x08; 

#define DDOT1	LCDDATA21 |= 0x10; 
#define DDOT2	LCDDATA21 |= 0x80;
#define DDOT3	LCDDATA22 |= 0x10; 
#define DDOT4	LCDDATA22 |= 0x80;
#define DDOT5	LCDDATA23 |= 0x08; 

#define OLIMEX	LCDDATA20 |= 0x80; 
#define MINUS	LCDDATA5  |= 0x80; 
#define PLUS	LCDDATA23 |= 0x80;



/**** CLK segments ****/
//lcd small 1
#define a1  		LCDDATA0  |= 0x02;
#define b1  		LCDDATA0  |= 0x01; 
#define c1  		LCDDATA12 |= 0x01;
#define d1  		LCDDATA18 |= 0x01;
#define e1  		LCDDATA12 |= 0x02; 
#define f1  		LCDDATA6  |= 0x02; 
#define g1  		LCDDATA6  |= 0x01; 

//lcd small 2
#define a2  		LCDDATA0  |= 0x08; 
#define b2  		LCDDATA0  |= 0x04;	 
#define c2  		LCDDATA12 |= 0x04;
#define d2  		LCDDATA18 |= 0x04; 
#define e2  		LCDDATA12 |= 0x08;
#define f2  		LCDDATA6  |= 0x08;
#define g2  		LCDDATA6  |= 0x04;


//lcd small 3
#define a3  		LCDDATA0  |= 0x10; 
#define b3  		LCDDATA6  |= 0x10; 
#define c3  		LCDDATA12 |= 0x10; 
#define d3  		LCDDATA18 |= 0x20; 
#define e3  		LCDDATA12 |= 0x20;
#define f3  		LCDDATA0  |= 0x20;
#define g3  		LCDDATA6  |= 0x20;


//lcd small 4
#define a4  		LCDDATA0  |= 0x40;
#define b4  		LCDDATA6  |= 0x40; 
#define c4  		LCDDATA12 |= 0x40;
#define d4  		LCDDATA18 |= 0x80;
#define e4  		LCDDATA12 |= 0x80;
#define f4  		LCDDATA0  |= 0x80;
#define g4  		LCDDATA6  |= 0x80;

#define dot1 		LCDDATA18 |= 0x02;
#define dot2 		LCDDATA18 |= 0x10;
#define dot3 		LCDDATA18 |= 0x40;
#define ddot 		LCDDATA18 |= 0x08;
#define dot_off		LCDDATA18 &= ~0x5A;

#define all_clk_off LCDDATA0 = 0; LCDDATA6 = 0; LCDDATA12 = 0; LCDDATA18 &= ~0xA5; 


/**** arrow segments ****/
#define arr_l  		LCDDATA1 	|= 0x01;
#define arr_r		LCDDATA13 	|= 0x01;
#define arr_d		LCDDATA19 	|= 0x01;
#define arr_u		LCDDATA7 	|= 0x01;
#define arr_off 	LCDDATA1 &= ~0x01; LCDDATA13 &= ~0x01; LCDDATA19 &= ~0x01; LCDDATA7 &= ~0x01;

#define lbat_start_end		LCDDATA1 	|= 0x02;
#define lbat_1				LCDDATA19 	|= 0x02;
#define lbat_2				LCDDATA13 	|= 0x02;
#define lbat_3				LCDDATA7 	|= 0x02;

#define progress_end		LCDDATA2 	|= 0x01;
#define progress_1			LCDDATA14 	|= 0x04;
#define progress_2			LCDDATA8 	|= 0x04;
#define progress_3			LCDDATA2 	|= 0x04;
#define progress_4			LCDDATA2 	|= 0x02;
#define progress_5			LCDDATA8 	|= 0x02;
#define progress_6			LCDDATA14 	|= 0x02;
#define progress_7			LCDDATA20 	|= 0x02;
#define progress_8			LCDDATA20 	|= 0x01;
#define progress_9			LCDDATA14 	|= 0x01;
#define progress_10			LCDDATA8 	|= 0x01;
#define progress_start		LCDDATA20 	|= 0x04;
#define progres_off			LCDDATA2 &= ~0x07; LCDDATA8 &= ~0x07;  LCDDATA14 &= ~0x07; LCDDATA20 &= ~0x07; 


#define F	LCDDATA2 	|= 0x08;
#define H	LCDDATA8 	|= 0x08;
#define m	LCDDATA14 	|= 0x08;
#define u	LCDDATA20 	|= 0x08;


// LCD Functions //
// Init LCD
void InitLCD(void);

// turn on All segment
void LCD_light_all(void);

// turn off All segment
void LCD_clear_all(void);

// write char to Xth position
void FormatChar_7(unsigned char ch);
void FormatChar_6(unsigned char ch);
void FormatChar_5(unsigned char ch);
void FormatChar_4(unsigned char ch);
void FormatChar_3(unsigned char ch);
void FormatChar_2(unsigned char ch);
void FormatChar_1(unsigned char ch);

// write char to Xth clock position
void FormatClk_1(unsigned char n);
void FormatClk_2(unsigned char n);
void FormatClk_3(unsigned char n);
void FormatClk_4(unsigned char n);

// Write number at clock position
void LCDWriteClck(unsigned int number);

// Write 7charakter text
void LCDWriteTxt(unsigned char* txt);

// Print current clock
void LCDPrintClck(char hour, char min);








