//PROGRAMM FOR LCD
//
// PROCESSOR : PIC18LF8490
// CLOCK	 : 20MHz, EXTERNAL


#include <pic18.h>
#include "lcd.h"

// Configuration bit
__CONFIG(1, HS & FCMDIS & IESODIS) ;
__CONFIG(2, PWRTDIS & WDTDIS & BORDIS & BORV20) ;
__CONFIG(3, CCP2RC1 & LPT1DIS & MCLRDIS) ;
__CONFIG(4, XINSTEN & STVREN) ;
__CONFIG(5, UNPROTECT) ;


//Just simple delay
// simple delay ~mS
void Delay_mS(unsigned long a) { 
	 a *= 370;
	while (--a!=0); 
}

// simple delay ~100us
void Delay_100uS(unsigned long a) { 
	 a *= 37;
	while (--a!=0); 
}

// main function
void main( void ) {


	INTCON 	= 0x0; 	 	// disable interupt
	ADCON1 	= 0x0F;		// all pins as IO
	CMCON	= 0x07;		// comparators off 

	// Init LCD
	InitLCD();

	// All LCD  
	LCD_light_all();	
	Delay_mS(1000);
	
	// Clear LCD
	LCD_clear_all();	
	Delay_mS(1000);

	// Write to LCD
	FormatChar_1('P'); 
	FormatChar_2('I'); 
	FormatChar_3('C'); 
	FormatChar_4('-'); 
	FormatChar_5('L'); 
	FormatChar_6('C'); 	
	FormatChar_7('D');

	// loop forever 
	while(1) {

	}
}
